// DOMDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DOMDemo.h"
#include "DOMDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDOMDemoDlg dialog

CDOMDemoDlg::CDOMDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDOMDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDOMDemoDlg)
	m_strFilename = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDOMDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDOMDemoDlg)
	DDX_Control(pDX, IDC_EXPANDALL, m_CExpandBtn);
	DDX_Control(pDX, IDC_COLLAPSEALL, m_CCollapseBtn);
	DDX_Control(pDX, IDC_XMLTREE, m_CXMLTree);
	DDX_Text(pDX, IDC_FILENAME, m_strFilename);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDOMDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDOMDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_EXPANDALL, OnExpandAll)
	ON_BN_CLICKED(IDC_COLLAPSEALL, OnCollapseAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDOMDemoDlg message handlers

BOOL CDOMDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize the tree's image list
	CBitmap bmpIcons, bmpMask;
	bmpIcons.LoadBitmap(IDB_TREEICONS);
	bmpMask.LoadBitmap(IDB_TIMASK);
	m_CILTree.Create(18,18,ILC_COLOR8|ILC_MASK,5,0);
	m_CILTree.Add(&bmpIcons,&bmpMask);

	// Provide images to the tree control
	m_CXMLTree.SetImageList(&m_CILTree,TVSIL_NORMAL);
	
	// Set the custom button mode
	m_CExpandBtn.SetExpandMode(TRUE);
	m_CCollapseBtn.SetExpandMode(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDOMDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDOMDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDOMDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Warning 4101 is the "unreferenced local variable", and the
// compiler is complaining I'm not using hrError in the catch()
// block.  I could, but in this case I'm blowing off the
// warning altogether...
#pragma warning(disable : 4101)
void CDOMDemoDlg::CreateXMLTree(IXMLDOMNode* pNode, HTREEITEM hParent /*=TVI_ROOT*/)
{
	// Quick check
	ASSERT(pNode != NULL);
	if ( pNode == NULL ) return;

	// Disallow redraws...
	m_CXMLTree.SetRedraw(FALSE);

	try {
		// Create local copy of the node
		CComPtr<IXMLDOMNode> spCurrent(pNode);

		// Retrieve node type
		DOMNodeType eNodeType; // node type enumeration
		HRESULT hr = spCurrent->get_nodeType(&eNodeType);
		if ( FAILED(hr) ) throw(hr);

		// Retrieve node name
		CComBSTR bstrNodeName;
		CString strName;
		hr = spCurrent->get_nodeName(&bstrNodeName);
		if ( FAILED(hr) ) throw(hr);
		strName = bstrNodeName;

		// Look for a value...
		CComVariant vNodeValue;
		hr = spCurrent->get_nodeValue(&vNodeValue);
		if ( FAILED(hr) ) throw(hr);
		CString strValue;
		strValue = vNodeValue.bstrVal;

		// Precompute a tree node string
		CString strNode;
		strNode.Format("%s {%s}",strName,strValue);

		// Stuff node types we want to handle into the tree. If the
		// node is a standard element node, we'll check for more
		// information.  If not, we'll insert the node and exit.
		HTREEITEM hCurrent = NULL;
		switch ( eNodeType ) {
			case NODE_TEXT:
				// Add text node to tree
				m_CXMLTree.InsertItem(strNode,XML_TEXT,XML_TEXT,hParent);
				return;

			case NODE_CDATA_SECTION:
				// Add CDATA node to tree
				m_CXMLTree.InsertItem(strNode,XML_CDATA,XML_CDATA,hParent);
				return;	
				
			case NODE_COMMENT:
				// Add comment node to tree
				m_CXMLTree.InsertItem(strNode,XML_COMMENT,XML_COMMENT,hParent);
				return;

			default:
				// Standard element nodes, so check to see if the node
				// is the root node and mark it as such.
				if ( hParent == TVI_ROOT ) {
					// Root
					hCurrent = m_CXMLTree.InsertItem(strName,XML_ROOT,XML_ROOT,hParent);
				} // if
				else {
					// Interior node
					hCurrent = m_CXMLTree.InsertItem(strName,XML_ELEMENT,XML_ELEMENT,hParent);
				} // else
				break;
		} // switch

		// If we got here, we're dealing with a standard node (root or
		// interior), so dive in and retrieve the list of attributes.
		CComPtr<IXMLDOMNamedNodeMap> spAttributes;
		hr = spCurrent->get_attributes(&spAttributes);
		if ( FAILED(hr) ) throw(hr);
	
		// Get current node's attributes...
		CComPtr<IXMLDOMNode> spChild;
		if ( spAttributes.p != NULL ) {
			hr = spAttributes->nextNode(&spChild);

			while ( SUCCEEDED(hr) && spChild.p ) {
				// Look for attributes...
				CComBSTR bstrAttName;
				hr = spChild->get_nodeName(&bstrAttName);
				if ( FAILED(hr) ) throw(hr);

				// Reset node name to attribute
				strName = bstrAttName;

				// Look for a value...
				CComVariant vAttValue;
				hr = spChild->get_nodeValue(&vAttValue);
				if ( FAILED(hr) ) throw(hr);
				strValue = vAttValue.bstrVal;

				// Add attribute node to tree
				CString strNode;
				strNode.Format("%s {%s}",strName,strValue);
				m_CXMLTree.InsertItem(strNode,XML_ATTRIBUTE,XML_ATTRIBUTE,hCurrent);

				// Next attribute...while test will catch failed
				// HRESULT...
				hr = spAttributes->nextNode(&spChild.p);
			} // while
		} // if

		// Now recurse through all child nodes
		hr = spCurrent->get_firstChild(&spChild);
		while ( SUCCEEDED(hr) && spChild.p ) {
			// Recurse
			CreateXMLTree(spChild.p, hCurrent);

			// Get next node
			CComPtr<IXMLDOMNode> spNext;
			hr = spChild->get_nextSibling(&spNext);
			spChild.Attach(spNext.Detach());
		} // while
	} // try
	catch(HRESULT hrError) {
		// Some error...
		AfxMessageBox(IDS_E_NOBUILDTREE,MB_OK|MB_ICONERROR);
	} // catch
	catch(...) {
		// Some error...
		AfxMessageBox(IDS_E_NOBUILDTREE,MB_OK|MB_ICONERROR);
	} // catch

	// Allow redraws...
	m_CXMLTree.SetRedraw(TRUE);
}
#pragma warning(default : 4101)

void CDOMDemoDlg::FillXMLTree(IXMLDOMDocument* pXMLDoc)
{
	// Display hourglass...
	CWaitCursor wc;

	// Clear any previous items
	m_CXMLTree.DeleteAllItems();

	// Pull XML information
	CComPtr<IXMLDOMElement> spDocElement;
	CComQIPtr<IXMLDOMNode> spRootNode;

	HRESULT hr = pXMLDoc->get_documentElement(&spDocElement);
	if ( SUCCEEDED(hr) ) {
		// With the document element in hand, QI() for the root
		// node object
		spRootNode = spDocElement;

		// Create the tree
		CreateXMLTree(spRootNode);

		// Expand tree from root
		HTREEITEM htiRoot = m_CXMLTree.GetRootItem();
		ExpandBranch(htiRoot,TVE_EXPAND);
		m_CXMLTree.SelectItem(htiRoot);
		m_CXMLTree.EnsureVisible(htiRoot);
	} // if
	else {
		// Some error...
		AfxMessageBox(IDS_E_NOBUILDTREE,MB_OK|MB_ICONERROR);
	} // else
}

#pragma warning(disable : 4101)
void CDOMDemoDlg::OnOpen() 
{
	// XML file filter
	static char szBrowseFilter[] = "XML Document (*.xml)|*.xml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";

	// Bring up standard file open dialog...
	CFileDialog dlg(TRUE,_T("xml"),NULL,OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,szBrowseFilter);
	dlg.m_ofn.lpstrTitle = _T("Open XML Document");
	if (dlg.DoModal() == IDOK) {
		// Open the file...
		try {
			// Create an instance of the XML processor
			CComPtr<IXMLDOMDocument> spXMLDoc;
			HRESULT hr = spXMLDoc.CoCreateInstance(__uuidof(DOMDocument));
			if ( FAILED(hr) ) throw hr;

			// Load the requested XML file
			VARIANT_BOOL bSuccess;
			hr = spXMLDoc->load(CComVariant(dlg.m_ofn.lpstrFile),&bSuccess);
			if ( FAILED(hr) || !bSuccess ) throw hr;

			// Fill the tree control
			FillXMLTree(spXMLDoc);

			// Fill the filename variable
			m_strFilename = dlg.m_ofn.lpstrFile;
			UpdateData(FALSE);
		} // try
		catch (HRESULT hrError) {
			// MFC file I/O exception...
			AfxMessageBox(IDS_E_NOOPENFILE,MB_OK|MB_ICONERROR);
		} // catch
		catch(...) {
			// Generic error
			AfxMessageBox(IDS_E_UNKOPENERR,MB_OK|MB_ICONERROR);
		} // catch
	} // if
}
#pragma warning(default : 4101)

void CDOMDemoDlg::ExpandBranch(HTREEITEM hti, UINT nHint)
{
	if( m_CXMLTree.ItemHasChildren(hti) ){
		m_CXMLTree.Expand(hti,nHint);
		hti = m_CXMLTree.GetChildItem(hti);
		do {
			ExpandBranch(hti,nHint);
		} while( (hti = m_CXMLTree.GetNextSiblingItem(hti)) != NULL );
	} // if
}

void CDOMDemoDlg::OnExpandAll() 
{
	// Expand all nodes
	m_CXMLTree.SetRedraw(FALSE);
	HTREEITEM hti = m_CXMLTree.GetRootItem();
	while ( hti != NULL ) {
		// Expand this branch
		ExpandBranch(hti,TVE_EXPAND);

		// Find next branch
		hti = m_CXMLTree.GetNextSiblingItem(hti);
	} // while

	// Show selected node
	m_CXMLTree.EnsureVisible(m_CXMLTree.GetSelectedItem());
	m_CXMLTree.SetRedraw(TRUE);
}

void CDOMDemoDlg::OnCollapseAll() 
{
	// Collapse all nodes
	m_CXMLTree.SetRedraw(FALSE);
	HTREEITEM hti = m_CXMLTree.GetRootItem();
	while ( hti != NULL ) {
		// Collapse this branch
		ExpandBranch(hti,TVE_COLLAPSE);

		// Find next branch
		hti = m_CXMLTree.GetNextSiblingItem(hti);
	} // while

	// Show selected node
	m_CXMLTree.EnsureVisible(m_CXMLTree.GetSelectedItem());
	m_CXMLTree.SetRedraw(TRUE);
}
