// DOMDemoDlg.h : header file
//

#if !defined(AFX_DOMDEMODLG_H__D4283F09_D500_11D3_87C0_E0610CC1652B__INCLUDED_)
#define AFX_DOMDEMODLG_H__D4283F09_D500_11D3_87C0_E0610CC1652B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XML support
#include <msxml.h>

// Custom button support
#include "InkedButton.h"

/////////////////////////////////////////////////////////////////////////////
// CDOMDemoDlg dialog

class CDOMDemoDlg : public CDialog
{
// Construction
public:
	CDOMDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDOMDemoDlg)
	enum { IDD = IDD_DOMDEMO_DIALOG };
	CInkedButton	m_CExpandBtn;
	CInkedButton	m_CCollapseBtn;
	CTreeCtrl	m_CXMLTree;
	CString	m_strFilename;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDOMDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	void CreateXMLTree(IXMLDOMNode* pNode, HTREEITEM hParent = TVI_ROOT);
	void FillXMLTree(IXMLDOMDocument* pXMLDoc);
	void ExpandBranch(HTREEITEM hti, UINT nHint);

// Implementation
protected:
	HICON m_hIcon;
	CImageList m_CILTree;
	enum { XML_ELEMENT = 0, XML_ROOT, XML_TEXT, XML_ATTRIBUTE, XML_COMMENT, XML_CDATA };

	// Generated message map functions
	//{{AFX_MSG(CDOMDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOpen();
	afx_msg void OnExpandAll();
	afx_msg void OnCollapseAll();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DOMDEMODLG_H__D4283F09_D500_11D3_87C0_E0610CC1652B__INCLUDED_)
